Supporting materials for "Determination of Nonlinear Genetic Architecture using Compressed Sensing".
====================================================================================================
Chiu Man Ho; Stephen D. H. Hsu 
(2015) GigaScience Database. 
http://dx.doi.org/10.5524/100162

The files available in this dataset are mostly MatLab scripts and the resultant files. Users should read the Manual.pdf file for instructions on script usage.

Files
-----

| File | Description      |
| :------ | :------------ |
| BD_100.m | matlab script for BD model with s=60 and s.=40 |
| BD_50.m | matlab script for BD model with s=30 and s.=20 |
| BD_5.m | matlab script for BD model with s=3 and s.=2 |
| BD_Generate_A_Randn_100.m | matlab script for generates A_Matrix and RandomVector for BD_100.m |
| BD_Generate_A_Randn_50.m | matlab script for generates A_Matrix and RandomVector for BD_50.m |
| BD_Generate_A_Randn_5.m | matlab script for generates A_Matrix and RandomVector for BD_5.m |
| BD_plot_figures.m | matlab script for generates all figures related to BD model |
| Continue_32.m | matlab script for model with continuous sensing matrix |
| Continue_Generate_A_Randn_32.m | matlab script for generates A_Matrix and RandomVector for Continue_32.m |
| Continue_PS_plot_figures.m | matlab script for generates all figures related to model with continuous sensing matrix |
| Data_BD_5.m | matlab script for BD model with s=3 and s.=2 with real genotype |
| Data_BD_plot_figures.m | matlab script for generates all figures related to BD model with real genotype |
| Data_PS_32.m | matlab script for PS model with s=3 and s.=2 with real genotype |
| Data_PS_plot_figures.m | matlab script for generates all figures related to PS model with real genotype |
| lasso_sv.m | matlab script for runs lasso |
| lse.m | matlab script for calculates p-values |
| Manual.pdf | manual for running the matlab scripts |
| PS_3020.m | matlab script for PS model with s=30 and s.=20 |
| PS_32.m | matlab script for PS model with s=3 and s.=2 |
| PS_32_Pvalue.m | matlab script for generates the phase transition figure |
| PS_32_y_vs_A.m | matlab script for plots y against A |
| PS_6040.m | matlab script for PS model with s=60 and s.=40 |
| PS_Generate_A_Randn_3020.m | matlab script for generates A_Matrix and RandomVector for PS_3020.m |
| PS_Generate_A_Randn_32.m | matlab script for generates A_Matrix and RandomVector for PS_32.m |
| PS_Generate_A_Randn_6040.m | matlab script for generates A_Matrix and RandomVector for PS_6040.m |
| PS_plot_figures.m | matlab script for generates all figures related to PS model |
| Table.m | matlab script for generates Table 1 |
| RandomVector | noise vector for s=3 and s.=2 for both BD and PS models |
| RandomVector_big | noise vector for s=30 and s.=20 for PS model |
| RandomVector_big_BD | noise vector for s=30 and s.=20 for BD model |
| RandomVector_bigger | noise vector for s=60 and s.=40 for PS model |
| RandomVector_bigger_BD | noise vector for s=60 and s.=40 for BD model |
| RandomVector_con | noise vector for s=3 and s.=2 for model with continuous sensing matrix |
